<?php

namespace eBizCharge\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfApplicationTransactionDetails ArrayType
 * @subpackage Arrays
 */
class ArrayOfApplicationTransactionDetails extends AbstractStructArrayBase
{
    /**
     * The ApplicationTransactionDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \eBizCharge\StructType\ApplicationTransactionDetails[]
     */
    public $ApplicationTransactionDetails;
    /**
     * Constructor method for ArrayOfApplicationTransactionDetails
     * @uses ArrayOfApplicationTransactionDetails::setApplicationTransactionDetails()
     * @param \eBizCharge\StructType\ApplicationTransactionDetails[] $applicationTransactionDetails
     */
    public function __construct(array $applicationTransactionDetails = array())
    {
        $this
            ->setApplicationTransactionDetails($applicationTransactionDetails);
    }
    /**
     * Get ApplicationTransactionDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \eBizCharge\StructType\ApplicationTransactionDetails[]|null
     */
    public function getApplicationTransactionDetails()
    {
        return isset($this->ApplicationTransactionDetails) ? $this->ApplicationTransactionDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setApplicationTransactionDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setApplicationTransactionDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateApplicationTransactionDetailsForArrayConstraintsFromSetApplicationTransactionDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfApplicationTransactionDetailsApplicationTransactionDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfApplicationTransactionDetailsApplicationTransactionDetailsItem instanceof \eBizCharge\StructType\ApplicationTransactionDetails) {
                $invalidValues[] = is_object($arrayOfApplicationTransactionDetailsApplicationTransactionDetailsItem) ? get_class($arrayOfApplicationTransactionDetailsApplicationTransactionDetailsItem) : sprintf('%s(%s)', gettype($arrayOfApplicationTransactionDetailsApplicationTransactionDetailsItem), var_export($arrayOfApplicationTransactionDetailsApplicationTransactionDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ApplicationTransactionDetails property can only contain items of type \eBizCharge\StructType\ApplicationTransactionDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ApplicationTransactionDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\ApplicationTransactionDetails[] $applicationTransactionDetails
     * @return \eBizCharge\ArrayType\ArrayOfApplicationTransactionDetails
     */
    public function setApplicationTransactionDetails(array $applicationTransactionDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($applicationTransactionDetailsArrayErrorMessage = self::validateApplicationTransactionDetailsForArrayConstraintsFromSetApplicationTransactionDetails($applicationTransactionDetails))) {
            throw new \InvalidArgumentException($applicationTransactionDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($applicationTransactionDetails) || (is_array($applicationTransactionDetails) && empty($applicationTransactionDetails))) {
            unset($this->ApplicationTransactionDetails);
        } else {
            $this->ApplicationTransactionDetails = $applicationTransactionDetails;
        }
        return $this;
    }
    /**
     * Add item to ApplicationTransactionDetails value
     * @throws \InvalidArgumentException
     * @param \eBizCharge\StructType\ApplicationTransactionDetails $item
     * @return \eBizCharge\ArrayType\ArrayOfApplicationTransactionDetails
     */
    public function addToApplicationTransactionDetails(\eBizCharge\StructType\ApplicationTransactionDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \eBizCharge\StructType\ApplicationTransactionDetails) {
            throw new \InvalidArgumentException(sprintf('The ApplicationTransactionDetails property can only contain items of type \eBizCharge\StructType\ApplicationTransactionDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ApplicationTransactionDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \eBizCharge\StructType\ApplicationTransactionDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \eBizCharge\StructType\ApplicationTransactionDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \eBizCharge\StructType\ApplicationTransactionDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \eBizCharge\StructType\ApplicationTransactionDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \eBizCharge\StructType\ApplicationTransactionDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ApplicationTransactionDetails
     */
    public function getAttributeName()
    {
        return 'ApplicationTransactionDetails';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \eBizCharge\ArrayType\ArrayOfApplicationTransactionDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
