<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EmailTemplate StructType
 * @subpackage Structs
 */
class EmailTemplate extends AbstractStructBase
{
    /**
     * The TemplateName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TemplateName;
    /**
     * The TemplateInternalId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TemplateInternalId;
    /**
     * The TemplateSubject
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TemplateSubject;
    /**
     * The TemplateDescription
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TemplateDescription;
    /**
     * The TemplateHTML
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TemplateHTML;
    /**
     * The TemplateText
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TemplateText;
    /**
     * The FromEmail
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FromEmail;
    /**
     * The FromName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FromName;
    /**
     * The ReplyToEmail
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReplyToEmail;
    /**
     * The ReplyToDisplayName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReplyToDisplayName;
    /**
     * The TemplateSource
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TemplateSource;
    /**
     * The TemplateTypeId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TemplateTypeId;
    /**
     * Constructor method for EmailTemplate
     * @uses EmailTemplate::setTemplateName()
     * @uses EmailTemplate::setTemplateInternalId()
     * @uses EmailTemplate::setTemplateSubject()
     * @uses EmailTemplate::setTemplateDescription()
     * @uses EmailTemplate::setTemplateHTML()
     * @uses EmailTemplate::setTemplateText()
     * @uses EmailTemplate::setFromEmail()
     * @uses EmailTemplate::setFromName()
     * @uses EmailTemplate::setReplyToEmail()
     * @uses EmailTemplate::setReplyToDisplayName()
     * @uses EmailTemplate::setTemplateSource()
     * @uses EmailTemplate::setTemplateTypeId()
     * @param string $templateName
     * @param string $templateInternalId
     * @param string $templateSubject
     * @param string $templateDescription
     * @param string $templateHTML
     * @param string $templateText
     * @param string $fromEmail
     * @param string $fromName
     * @param string $replyToEmail
     * @param string $replyToDisplayName
     * @param string $templateSource
     * @param string $templateTypeId
     */
    public function __construct($templateName = null, $templateInternalId = null, $templateSubject = null, $templateDescription = null, $templateHTML = null, $templateText = null, $fromEmail = null, $fromName = null, $replyToEmail = null, $replyToDisplayName = null, $templateSource = null, $templateTypeId = null)
    {
        $this
            ->setTemplateName($templateName)
            ->setTemplateInternalId($templateInternalId)
            ->setTemplateSubject($templateSubject)
            ->setTemplateDescription($templateDescription)
            ->setTemplateHTML($templateHTML)
            ->setTemplateText($templateText)
            ->setFromEmail($fromEmail)
            ->setFromName($fromName)
            ->setReplyToEmail($replyToEmail)
            ->setReplyToDisplayName($replyToDisplayName)
            ->setTemplateSource($templateSource)
            ->setTemplateTypeId($templateTypeId);
    }
    /**
     * Get TemplateName value
     * @return string|null
     */
    public function getTemplateName()
    {
        return $this->TemplateName;
    }
    /**
     * Set TemplateName value
     * @param string $templateName
     * @return \eBizCharge\StructType\EmailTemplate
     */
    public function setTemplateName($templateName = null)
    {
        // validation for constraint: string
        if (!is_null($templateName) && !is_string($templateName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($templateName, true), gettype($templateName)), __LINE__);
        }
        $this->TemplateName = $templateName;
        return $this;
    }
    /**
     * Get TemplateInternalId value
     * @return string|null
     */
    public function getTemplateInternalId()
    {
        return $this->TemplateInternalId;
    }
    /**
     * Set TemplateInternalId value
     * @param string $templateInternalId
     * @return \eBizCharge\StructType\EmailTemplate
     */
    public function setTemplateInternalId($templateInternalId = null)
    {
        // validation for constraint: string
        if (!is_null($templateInternalId) && !is_string($templateInternalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($templateInternalId, true), gettype($templateInternalId)), __LINE__);
        }
        $this->TemplateInternalId = $templateInternalId;
        return $this;
    }
    /**
     * Get TemplateSubject value
     * @return string|null
     */
    public function getTemplateSubject()
    {
        return $this->TemplateSubject;
    }
    /**
     * Set TemplateSubject value
     * @param string $templateSubject
     * @return \eBizCharge\StructType\EmailTemplate
     */
    public function setTemplateSubject($templateSubject = null)
    {
        // validation for constraint: string
        if (!is_null($templateSubject) && !is_string($templateSubject)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($templateSubject, true), gettype($templateSubject)), __LINE__);
        }
        $this->TemplateSubject = $templateSubject;
        return $this;
    }
    /**
     * Get TemplateDescription value
     * @return string|null
     */
    public function getTemplateDescription()
    {
        return $this->TemplateDescription;
    }
    /**
     * Set TemplateDescription value
     * @param string $templateDescription
     * @return \eBizCharge\StructType\EmailTemplate
     */
    public function setTemplateDescription($templateDescription = null)
    {
        // validation for constraint: string
        if (!is_null($templateDescription) && !is_string($templateDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($templateDescription, true), gettype($templateDescription)), __LINE__);
        }
        $this->TemplateDescription = $templateDescription;
        return $this;
    }
    /**
     * Get TemplateHTML value
     * @return string|null
     */
    public function getTemplateHTML()
    {
        return $this->TemplateHTML;
    }
    /**
     * Set TemplateHTML value
     * @param string $templateHTML
     * @return \eBizCharge\StructType\EmailTemplate
     */
    public function setTemplateHTML($templateHTML = null)
    {
        // validation for constraint: string
        if (!is_null($templateHTML) && !is_string($templateHTML)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($templateHTML, true), gettype($templateHTML)), __LINE__);
        }
        $this->TemplateHTML = $templateHTML;
        return $this;
    }
    /**
     * Get TemplateText value
     * @return string|null
     */
    public function getTemplateText()
    {
        return $this->TemplateText;
    }
    /**
     * Set TemplateText value
     * @param string $templateText
     * @return \eBizCharge\StructType\EmailTemplate
     */
    public function setTemplateText($templateText = null)
    {
        // validation for constraint: string
        if (!is_null($templateText) && !is_string($templateText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($templateText, true), gettype($templateText)), __LINE__);
        }
        $this->TemplateText = $templateText;
        return $this;
    }
    /**
     * Get FromEmail value
     * @return string|null
     */
    public function getFromEmail()
    {
        return $this->FromEmail;
    }
    /**
     * Set FromEmail value
     * @param string $fromEmail
     * @return \eBizCharge\StructType\EmailTemplate
     */
    public function setFromEmail($fromEmail = null)
    {
        // validation for constraint: string
        if (!is_null($fromEmail) && !is_string($fromEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fromEmail, true), gettype($fromEmail)), __LINE__);
        }
        $this->FromEmail = $fromEmail;
        return $this;
    }
    /**
     * Get FromName value
     * @return string|null
     */
    public function getFromName()
    {
        return $this->FromName;
    }
    /**
     * Set FromName value
     * @param string $fromName
     * @return \eBizCharge\StructType\EmailTemplate
     */
    public function setFromName($fromName = null)
    {
        // validation for constraint: string
        if (!is_null($fromName) && !is_string($fromName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fromName, true), gettype($fromName)), __LINE__);
        }
        $this->FromName = $fromName;
        return $this;
    }
    /**
     * Get ReplyToEmail value
     * @return string|null
     */
    public function getReplyToEmail()
    {
        return $this->ReplyToEmail;
    }
    /**
     * Set ReplyToEmail value
     * @param string $replyToEmail
     * @return \eBizCharge\StructType\EmailTemplate
     */
    public function setReplyToEmail($replyToEmail = null)
    {
        // validation for constraint: string
        if (!is_null($replyToEmail) && !is_string($replyToEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($replyToEmail, true), gettype($replyToEmail)), __LINE__);
        }
        $this->ReplyToEmail = $replyToEmail;
        return $this;
    }
    /**
     * Get ReplyToDisplayName value
     * @return string|null
     */
    public function getReplyToDisplayName()
    {
        return $this->ReplyToDisplayName;
    }
    /**
     * Set ReplyToDisplayName value
     * @param string $replyToDisplayName
     * @return \eBizCharge\StructType\EmailTemplate
     */
    public function setReplyToDisplayName($replyToDisplayName = null)
    {
        // validation for constraint: string
        if (!is_null($replyToDisplayName) && !is_string($replyToDisplayName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($replyToDisplayName, true), gettype($replyToDisplayName)), __LINE__);
        }
        $this->ReplyToDisplayName = $replyToDisplayName;
        return $this;
    }
    /**
     * Get TemplateSource value
     * @return string|null
     */
    public function getTemplateSource()
    {
        return $this->TemplateSource;
    }
    /**
     * Set TemplateSource value
     * @param string $templateSource
     * @return \eBizCharge\StructType\EmailTemplate
     */
    public function setTemplateSource($templateSource = null)
    {
        // validation for constraint: string
        if (!is_null($templateSource) && !is_string($templateSource)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($templateSource, true), gettype($templateSource)), __LINE__);
        }
        $this->TemplateSource = $templateSource;
        return $this;
    }
    /**
     * Get TemplateTypeId value
     * @return string|null
     */
    public function getTemplateTypeId()
    {
        return $this->TemplateTypeId;
    }
    /**
     * Set TemplateTypeId value
     * @param string $templateTypeId
     * @return \eBizCharge\StructType\EmailTemplate
     */
    public function setTemplateTypeId($templateTypeId = null)
    {
        // validation for constraint: string
        if (!is_null($templateTypeId) && !is_string($templateTypeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($templateTypeId, true), gettype($templateTypeId)), __LINE__);
        }
        $this->TemplateTypeId = $templateTypeId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \eBizCharge\StructType\EmailTemplate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
