<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetReceiptsList StructType
 * @subpackage Structs
 */
class GetReceiptsList extends AbstractStructBase
{
    /**
     * The securityToken
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\StructType\SecurityToken
     */
    public $securityToken;
    /**
     * The receiptType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $receiptType;
    /**
     * Constructor method for GetReceiptsList
     * @uses GetReceiptsList::setSecurityToken()
     * @uses GetReceiptsList::setReceiptType()
     * @param \eBizCharge\StructType\SecurityToken $securityToken
     * @param string $receiptType
     */
    public function __construct(\eBizCharge\StructType\SecurityToken $securityToken = null, $receiptType = null)
    {
        $this
            ->setSecurityToken($securityToken)
            ->setReceiptType($receiptType);
    }
    /**
     * Get securityToken value
     * @return \eBizCharge\StructType\SecurityToken|null
     */
    public function getSecurityToken()
    {
        return $this->securityToken;
    }
    /**
     * Set securityToken value
     * @param \eBizCharge\StructType\SecurityToken $securityToken
     * @return \eBizCharge\StructType\GetReceiptsList
     */
    public function setSecurityToken(\eBizCharge\StructType\SecurityToken $securityToken = null)
    {
        $this->securityToken = $securityToken;
        return $this;
    }
    /**
     * Get receiptType value
     * @return string|null
     */
    public function getReceiptType()
    {
        return $this->receiptType;
    }
    /**
     * Set receiptType value
     * @param string $receiptType
     * @return \eBizCharge\StructType\GetReceiptsList
     */
    public function setReceiptType($receiptType = null)
    {
        // validation for constraint: string
        if (!is_null($receiptType) && !is_string($receiptType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($receiptType, true), gettype($receiptType)), __LINE__);
        }
        $this->receiptType = $receiptType;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \eBizCharge\StructType\GetReceiptsList
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
