<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetTransactionDetails StructType
 * @subpackage Structs
 */
class GetTransactionDetails extends AbstractStructBase
{
    /**
     * The securityToken
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\StructType\SecurityToken
     */
    public $securityToken;
    /**
     * The transactionRefNum
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $transactionRefNum;
    /**
     * Constructor method for GetTransactionDetails
     * @uses GetTransactionDetails::setSecurityToken()
     * @uses GetTransactionDetails::setTransactionRefNum()
     * @param \eBizCharge\StructType\SecurityToken $securityToken
     * @param string $transactionRefNum
     */
    public function __construct(\eBizCharge\StructType\SecurityToken $securityToken = null, $transactionRefNum = null)
    {
        $this
            ->setSecurityToken($securityToken)
            ->setTransactionRefNum($transactionRefNum);
    }
    /**
     * Get securityToken value
     * @return \eBizCharge\StructType\SecurityToken|null
     */
    public function getSecurityToken()
    {
        return $this->securityToken;
    }
    /**
     * Set securityToken value
     * @param \eBizCharge\StructType\SecurityToken $securityToken
     * @return \eBizCharge\StructType\GetTransactionDetails
     */
    public function setSecurityToken(\eBizCharge\StructType\SecurityToken $securityToken = null)
    {
        $this->securityToken = $securityToken;
        return $this;
    }
    /**
     * Get transactionRefNum value
     * @return string|null
     */
    public function getTransactionRefNum()
    {
        return $this->transactionRefNum;
    }
    /**
     * Set transactionRefNum value
     * @param string $transactionRefNum
     * @return \eBizCharge\StructType\GetTransactionDetails
     */
    public function setTransactionRefNum($transactionRefNum = null)
    {
        // validation for constraint: string
        if (!is_null($transactionRefNum) && !is_string($transactionRefNum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionRefNum, true), gettype($transactionRefNum)), __LINE__);
        }
        $this->transactionRefNum = $transactionRefNum;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \eBizCharge\StructType\GetTransactionDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
