<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ModifyScheduledRecurringPaymentStatus StructType
 * @subpackage Structs
 */
class ModifyScheduledRecurringPaymentStatus extends AbstractStructBase
{
    /**
     * The statusId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $statusId;
    /**
     * The securityToken
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\StructType\SecurityToken
     */
    public $securityToken;
    /**
     * The scheduledPaymentInternalId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $scheduledPaymentInternalId;
    /**
     * Constructor method for ModifyScheduledRecurringPaymentStatus
     * @uses ModifyScheduledRecurringPaymentStatus::setStatusId()
     * @uses ModifyScheduledRecurringPaymentStatus::setSecurityToken()
     * @uses ModifyScheduledRecurringPaymentStatus::setScheduledPaymentInternalId()
     * @param int $statusId
     * @param \eBizCharge\StructType\SecurityToken $securityToken
     * @param string $scheduledPaymentInternalId
     */
    public function __construct($statusId = null, \eBizCharge\StructType\SecurityToken $securityToken = null, $scheduledPaymentInternalId = null)
    {
        $this
            ->setStatusId($statusId)
            ->setSecurityToken($securityToken)
            ->setScheduledPaymentInternalId($scheduledPaymentInternalId);
    }
    /**
     * Get statusId value
     * @return int
     */
    public function getStatusId()
    {
        return $this->statusId;
    }
    /**
     * Set statusId value
     * @param int $statusId
     * @return \eBizCharge\StructType\ModifyScheduledRecurringPaymentStatus
     */
    public function setStatusId($statusId = null)
    {
        // validation for constraint: int
        if (!is_null($statusId) && !(is_int($statusId) || ctype_digit($statusId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($statusId, true), gettype($statusId)), __LINE__);
        }
        $this->statusId = $statusId;
        return $this;
    }
    /**
     * Get securityToken value
     * @return \eBizCharge\StructType\SecurityToken|null
     */
    public function getSecurityToken()
    {
        return $this->securityToken;
    }
    /**
     * Set securityToken value
     * @param \eBizCharge\StructType\SecurityToken $securityToken
     * @return \eBizCharge\StructType\ModifyScheduledRecurringPaymentStatus
     */
    public function setSecurityToken(\eBizCharge\StructType\SecurityToken $securityToken = null)
    {
        $this->securityToken = $securityToken;
        return $this;
    }
    /**
     * Get scheduledPaymentInternalId value
     * @return string|null
     */
    public function getScheduledPaymentInternalId()
    {
        return $this->scheduledPaymentInternalId;
    }
    /**
     * Set scheduledPaymentInternalId value
     * @param string $scheduledPaymentInternalId
     * @return \eBizCharge\StructType\ModifyScheduledRecurringPaymentStatus
     */
    public function setScheduledPaymentInternalId($scheduledPaymentInternalId = null)
    {
        // validation for constraint: string
        if (!is_null($scheduledPaymentInternalId) && !is_string($scheduledPaymentInternalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($scheduledPaymentInternalId, true), gettype($scheduledPaymentInternalId)), __LINE__);
        }
        $this->scheduledPaymentInternalId = $scheduledPaymentInternalId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \eBizCharge\StructType\ModifyScheduledRecurringPaymentStatus
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
