<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SearchFilter StructType
 * @subpackage Structs
 */
class SearchFilter extends AbstractStructBase
{
    /**
     * The FieldName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FieldName;
    /**
     * The ComparisonOperator
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ComparisonOperator;
    /**
     * The FieldValue
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FieldValue;
    /**
     * Constructor method for SearchFilter
     * @uses SearchFilter::setFieldName()
     * @uses SearchFilter::setComparisonOperator()
     * @uses SearchFilter::setFieldValue()
     * @param string $fieldName
     * @param string $comparisonOperator
     * @param string $fieldValue
     */
    public function __construct($fieldName = null, $comparisonOperator = null, $fieldValue = null)
    {
        $this
            ->setFieldName($fieldName)
            ->setComparisonOperator($comparisonOperator)
            ->setFieldValue($fieldValue);
    }
    /**
     * Get FieldName value
     * @return string|null
     */
    public function getFieldName()
    {
        return $this->FieldName;
    }
    /**
     * Set FieldName value
     * @param string $fieldName
     * @return \eBizCharge\StructType\SearchFilter
     */
    public function setFieldName($fieldName = null)
    {
        // validation for constraint: string
        if (!is_null($fieldName) && !is_string($fieldName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fieldName, true), gettype($fieldName)), __LINE__);
        }
        $this->FieldName = $fieldName;
        return $this;
    }
    /**
     * Get ComparisonOperator value
     * @return string|null
     */
    public function getComparisonOperator()
    {
        return $this->ComparisonOperator;
    }
    /**
     * Set ComparisonOperator value
     * @param string $comparisonOperator
     * @return \eBizCharge\StructType\SearchFilter
     */
    public function setComparisonOperator($comparisonOperator = null)
    {
        // validation for constraint: string
        if (!is_null($comparisonOperator) && !is_string($comparisonOperator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($comparisonOperator, true), gettype($comparisonOperator)), __LINE__);
        }
        $this->ComparisonOperator = $comparisonOperator;
        return $this;
    }
    /**
     * Get FieldValue value
     * @return string|null
     */
    public function getFieldValue()
    {
        return $this->FieldValue;
    }
    /**
     * Set FieldValue value
     * @param string $fieldValue
     * @return \eBizCharge\StructType\SearchFilter
     */
    public function setFieldValue($fieldValue = null)
    {
        // validation for constraint: string
        if (!is_null($fieldValue) && !is_string($fieldValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fieldValue, true), gettype($fieldValue)), __LINE__);
        }
        $this->FieldValue = $fieldValue;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \eBizCharge\StructType\SearchFilter
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
